from conference_model import *
#Parameters that are going to vary
if __name__=="__main__":
    args=get_options()
    filters =[4]
    kernel_size= [2]
    epochs=500
    steps_per_epoch=20
    myGene = trainGenerator(3,"{}".format(args.path_to_folders),path_leaf("{}".format(args.imageTrain_directory)),path_leaf("{}".format(args.maskTrain_directory)),data_gen_args,save_to_dir= None)
    print("I have used the folder names as inserted")

    # This is the function that trains the images with their corresponding masks

    i=0
    for filter1 in filters:
        for kernel_siz in kernel_size:
            print(filter1,kernel_siz)
            i=i+1
            model = unet(filters=filter1 ,kernel_size=kernel_siz,output_channels=2)
            model_checkpoint = ModelCheckpoint('%d_weights.hdf5'%i, monitor='loss',verbose=1, save_best_only=True)
            model.compile(optimizer = Adam(lr = 1e-10), loss = 'binary_crossentropy', metrics = ['accuracy'])
            model.summary()
            history = model.fit_generator(myGene,steps_per_epoch=steps_per_epoch,epochs=epochs,callbacks=[model_checkpoint])

    #This is the function that tests unseen images to predict the unseen correspondng masks
    i=1
    testGene = testGenerator("{}/*.png".format(args.imageTest_directory))
    model.load_weights('%d_weights.hdf5'%i)
    results = model.predict_generator(testGene,3,verbose=0)
    print("Before Testing")
    np.save(args.filename, results)
    print("Done Testing!")

        #Viewing predictions
        # def show_predictions(dataset=None, num=1):
        #       if dataset:
        #         for image, mask in dataset.take(num):
        #           pred_mask = model.predict(image)
        #           display([image[0], mask[0], create_mask(pred_mask)])
        #       else:
        #         display([sample_image, sample_mask,
        #                  create_mask(model.predict(sample_image[tf.newaxis, ...]))])

    for i in range(0,3):
        data = np.load(args.filename)
        d = data[i,:,:,0]
        print(d)
        BoxPlot=np.quantile(d,([0,0.25,0.5,0.75,1]))
        hdu = fits.PrimaryHDU(d)
        hdul = fits.HDUList([hdu])
        if os.path.isfile("%dm1g.fits"%i):
            os.remove("%dm1g.fits"%i)
        else:
            print ("File  does not exist")

        hdul.writeto("%dtwo.fits"%i)
        plt.imshow(d) #Needs to be in row,col order
        plt.savefig("%dtwo.png"%i)

    print("Done saving files!")
